/***********************************************************

             YUV image input functions

 ***********************************************************/
  #include <stdio.h>
  #include <stdlib.h>
  #include <math.h>
  #include <string.h>



/*=======================================================
  -------------------------------------------------------
	YUV image input (double)
  -------------------------------------------------------
  [Argument]
          char	*file     Input file name
  -------------------------------------------------------
  [Return value]
lsImage	*     Pointer to image memory structure
  =======================================================*/
Image *yuvread( char *file, int x, int y)
{
    unsigned char	*buff,*b1; 
	unsigned char	*b2; // unsigned char
    FILE     		*fp;
    int      		i, j;
    Image		*img;

    if ((fp=fopen(file,"rb")) == NULL) exit( -1 );
     
      fprintf(stderr, "Reading YUV format, %d x %d image : %s\n", x, y, file);

    img = new_image(x, y, 3);

    buff = (unsigned char *)calloc(3 * x * y/2, sizeof( unsigned char ) ); //unsigned char
    if( buff == NULL ) exit( -1 );

    fread(buff, 1, 3 * x * y / 2, fp);
    b2 = img->data;
    b1 = buff;
    for ( i=0; i<3*y/2; i++ ){
      for ( j=0; j<x ;j++ ){
		  *b2++ = *b1++;
      }
    }
		
    fclose(fp);
    free(buff);

    return( img );
}

/*=======================================================
  -------------------------------------------------------
  Memory allocation
  -------------------------------------------------------
  [Argument]
    int width: width of image
    int height: height of image
  -------------------------------------------------------
  [Return Value]
    unsigned char**     Pointer to memory structure
  =======================================================*/

unsigned char **ByteAlloc(int width, int height)
{
	unsigned char *p, **pp ;
	pp = (unsigned char **)malloc (sizeof(unsigned char *) * height) ;
	pp[0] = (unsigned char *)malloc(sizeof(unsigned char) * width * height) ;
	p = pp[0] ;
	for (int i = 1; i < height; i++)
	{
		p += width ;
		pp[i] = p ;
	}
	return pp ;
}
